/*************************** (C) COPYRIGHT 2014 GLHF ****************************
 * 文件名  ：USART5.c
 * 描  述  ：串口5驱动代码   
 * 版  本  ：V1.0
 * 作  者  ：XuZhongPing
 * 日  期  ：2017/09/03 
*********************************************************************************/
#include "usart5.h"

uint8_t USART5_RX_BUF[USART5_RECV_LEN];			//最大接收缓存
uint8_t USART5_TX_BUF[USART5_SEND_LEN];			//最大发收缓存
uint8_t USART5_RX_STA = 0;       						//接收状态标记

void USART5_ReceiveHandler(uint8_t res);

/*
***********************************************************************
*	函 数 名: USART5_Init
*	功能说明: 初始化IO 串口5
*	形    参：bound:波特率	 
*	返 回 值: 无
***********************************************************************
*/
void USART5_Init(uint32_t bound)
{  	
	//GPIO端口设置
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
	 
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC | RCC_APB2Periph_GPIOD, ENABLE);
 	RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART5, ENABLE);

	//USART5_TX   PC.12
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOC, &GPIO_InitStructure);
   
	//USART5_RX	  PD.2
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;		//浮空输入
	GPIO_Init(GPIOD, &GPIO_InitStructure);  								//初始化PD.2

	//USART 初始化设置
	USART_InitStructure.USART_BaudRate = bound;																			//设置波特率;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;											//字长为8位数据格式
	USART_InitStructure.USART_StopBits = USART_StopBits_1;													//一个停止位
	USART_InitStructure.USART_Parity = USART_Parity_No;															//无奇偶校验位
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;	//无硬件数据流控制
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;									//收发模式
	USART_Init(UART5, &USART_InitStructure); 																				//初始化串口
	
	//Usart5 NVIC 配置
	NVIC_InitStructure.NVIC_IRQChannel = UART5_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=2 ;		//抢占优先级0
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;					//子优先级1
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;							//IRQ通道使能
	NVIC_Init(&NVIC_InitStructure);															//根据指定的参数初始化VIC寄存器
  
	USART_ITConfig(UART5, USART_IT_RXNE, ENABLE);			//开启中断
	USART_Cmd(UART5, ENABLE);													//使能串口
}

/*
***********************************************************************
*	函 数 名: UART5_IRQHandler
*	功能说明: 串口5中断服务处理子程序
*	形    参：无
*	返 回 值: 无
***********************************************************************
*/ 	 
void UART5_IRQHandler(void)
{
	uint8_t res = 0;
	
	if(USART_GetITStatus(UART5, USART_IT_RXNE) != RESET)  //接收中断(接收到的数据必须是0x0d 0x0a结尾)
	{
		res = USART_ReceiveData(UART5);
		USART5_ReceiveHandler(res);
	}									 
}   

/*
***********************************************************************
*	函 数 名: UART5_Send_Data
*	功能说明: 发送一个字节数据
*	形    参:	发送数据
*	返 回 值: 无
***********************************************************************
*/
void USART5_SendByteData(uint8_t Serial_data)
{
	USART_SendData(UART5, Serial_data);												//向串口发送数据
	while(USART_GetFlagStatus(UART5, USART_FLAG_TC) != SET);	//等待发送结束
}

/*
***********************************************************************
*	函 数 名: USART5_SendFrameData
*	功能说明: 发送一帧数据
*	形    参: pData -> 数据的首地址；len -> 数据的长度
*	返 回 值: 无
***********************************************************************
*/
void USART5_SendFrameData(uint8_t pDataBuf[], uint16_t len)
{
	uint16_t i = 0;
	
	USART_ClearFlag(UART5, USART_FLAG_TC);
	for(i = 0; i < len; i++)
	{
		USART5_SendByteData(pDataBuf[i]);
	}
}

/*
***********************************************************************
*	函 数 名: USART5_ReceiveHandler
*	功能说明: 串口数据接收处理程序
*	形    参: 传入串口接收到的数据
*	返 回 值: 无（影响串口接收状态USART5_RX_STA）
***********************************************************************
*/
void USART5_ReceiveHandler(uint8_t res)
{	
	static uint8_t Byte_count = 0;	  			//接收数据字节计数
	static uint8_t receiveState = 0;				//接收状态
		
	switch(receiveState)
	{
		case 0:	  //第一开始码
			
			break;

		default:  //其它
			break;
	}							 
}
 
/******************** (C) COPYRIGHT 2017 CXHY *****END OF FILE*******************/
